vshost-util-vserver

Build script and sources for util-vserver.
git clone https://ccx.te2000.cz/git/vshost-util-vserver
Log | Files | Refs

vserver-build.yum (2798B)


      1 # $Id$	--*- sh -*--
      2 
      3 # Copyright (C) 2005 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
      4 #  
      5 # This program is free software; you can redistribute it and/or modify
      6 # it under the terms of the GNU General Public License as published by
      7 # the Free Software Foundation; version 2 of the License.
      8 #  
      9 # This program is distributed in the hope that it will be useful,
     10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
     11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     12 # GNU General Public License for more details.
     13 #  
     14 # You should have received a copy of the GNU General Public License
     15 # along with this program; if not, write to the Free Software
     16 # Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
     17 
     18 tmp=$(getopt -o +d: --long debug -n "$0" -- "$@") || exit 1
     19 eval set -- "$tmp"
     20 
     21 . "$_LIB_VSERVER_BUILD_FUNCTIONS_RPM"
     22 . "$_LIB_VSERVER_BUILD_FUNCTIONS_YUM"
     23 . "$_LIB_VSERVER_BUILD_FUNCTIONS_PKGMGMT"
     24 
     25 while true; do
     26     case "$1" in
     27 	(-d)		DISTRIBUTION=$2; shift;;
     28 	(--debug)	set -x;;
     29 	(--)		shift; break ;;
     30 	(*)		echo "vserver-build.yum: internal error: unrecognized option '$1'" >&2
     31 			exit 1
     32 			;;
     33     esac
     34     shift
     35 done
     36 
     37 getDistribution
     38 
     39 base.init
     40 pkgmgmt.initVariables
     41 rpm.initVariables
     42 yum.initVariables
     43 
     44 rpm.sanityCheck
     45 
     46 
     47 base.initFilesystem    "$OPTION_FORCE"
     48 pkgmgmt.initFilesystem "$OPTION_FORCE"
     49 rpm.initFilesystem
     50 yum.initFilesystem
     51 
     52 setup_writeOption "$VSERVER_NAME"
     53 setup_writeInitialFstab
     54 
     55 test -z "$BUILD_INITPRE"  || "$BUILD_INITPRE" "$SETUP_CONFDIR"  "$UTIL_VSERVER_VARS"
     56 
     57 if $_VSERVER_INFO - FEATURE persistent; then
     58     $_VSPACE --new --mount --fs -- \
     59 	$_VCONTEXT --create ${SETUP_CONTEXT:+--xid "$SETUP_CONTEXT"} --silent -- \
     60 	$_VUNAME --set --xid self -t context="rpm-fake $SETUP_CONFDIR" -- \
     61 	$_VSPACE --set --mount --fs -- \
     62 	$_SAVE_CTXINFO "$SETUP_CONFDIR" \
     63 	$_VATTRIBUTE --set --xid self --secure --flag persistent -- \
     64 	$_VCONTEXT --xid self --migrate-self --endsetup -- \
     65 	/bin/true
     66     RPM_FAKE_CTX=`$_CAT $SETUP_CONFDIR/run`
     67     export RPM_FAKE_CTX
     68     base._addGeneratedFile "`$_READLINK $SETUP_CONFDIR/run`"
     69     base.pushCleanup $_VATTRIBUTE --xid "$RPM_FAKE_CTX" --flag '!persistent'
     70 fi
     71 
     72 rpm.initDB           "$SETUP_CONFDIR"
     73 rpm.importGPGPubKeys "$SETUP_CONFDIR" \
     74     "$__CONFDIR/.distributions/$DISTRIBUTION/pubkeys" \
     75     "$__CONFDIR/.distributions/.common/pubkeys" \
     76     "$__DISTRIBDIR/$DISTRIBUTION/pubkeys"
     77 yum.installBasePackages "$SETUP_CONFDIR" "$PKGINSTALLDIR"
     78 
     79 test -z "$1" || $_VYUM "$SETUP_CONFDIR" -- -y install "$@"
     80 
     81 $_VYUM "$SETUP_CONFDIR" -- clean all
     82 
     83 if $_VSERVER_INFO - FEATURE persistent; then
     84     base.popCleanup
     85     $_VATTRIBUTE --xid "$RPM_FAKE_CTX" --flag '!persistent'
     86 fi
     87 
     88 test -z "$BUILD_INITPOST" || "$BUILD_INITPOST" "$SETUP_CONFDIR" "$UTIL_VSERVER_VARS"
     89 
     90 base.setSuccess